<?xml version="1.0"?>
<ruleset name="PHPMD rule set for FIDESIO"
         xmlns="http://pmd.sf.net/ruleset/1.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sf.net/ruleset/1.0.0 http://pmd.sf.net/ruleset_xml_schema.xsd"
         xsi:noNamespaceSchemaLocation="http://pmd.sf.net/ruleset_xml_schema.xsd">

    <description>
        Custom ruleset for FIDESIO Symfony projects
    </description>

    <exclude-pattern>Migrations</exclude-pattern>

    <!-- Import the entire unused code rule set -->
    <rule ref="rulesets/design.xml">
        <exclude name="CouplingBetweenObjects"/>
    </rule>

    <!--Customize the rule "CouplingBetweenObjects" configuration.-->
    <rule ref="rulesets/design.xml/CouplingBetweenObjects">
        <priority>1</priority>
        <properties>
            <property name="minimum" value="20"/>
        </properties>
    </rule>

    <rule ref="rulesets/unusedcode.xml">
        <exclude name="UnusedFormalParameter"/>
    </rule>

    <rule ref="rulesets/cleancode.xml">
        <exclude name="StaticAccess"/>
        <exclude name="ElseExpression"/>
    </rule>

    <rule ref="rulesets/naming.xml">
        <exclude name="ShortVariable"/>
    </rule>
    <rule ref="rulesets/naming.xml/ShortVariable">
        <priority>1</priority>
        <properties>
            <property name="minimum" description="Minimum length for a variable, property or parameter name" value="2"/>
            <property name="exceptions" value="i,j,k,v"/>
        </properties>
    </rule>

    <rule ref="rulesets/codesize.xml">
        <exclude name="CyclomaticComplexity"/>
        <exclude name="TooManyFields"/>
        <exclude name="TooManyMethods"/>
        <exclude name="TooManyPublicMethods"/>
    </rule>
    <rule ref="rulesets/codesize.xml/CyclomaticComplexity">
        <priority>1</priority>
        <properties>
            <property name="minimum" value="15"/>
        </properties>
    </rule>
    <rule ref="rulesets/codesize.xml/TooManyFields">
        <priority>1</priority>
        <properties>
            <property name="maxfields" value="20"/>
        </properties>
    </rule>
    <rule ref="rulesets/codesize.xml/TooManyMethods">
        <priority>1</priority>
        <properties>
            <property name="maxmethods" value="15"/>
        </properties>
    </rule>

</ruleset>
